/*****************************************************************************
 This file is part of the Changedfiles system. 
 $Id: syscalls.h,v 1.1 2003/01/11 13:38:55 rocky Exp $

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or (at
 your option) any later version.

 This program is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA
******************************************************************************/

#ifndef _SYSCALLS_H
#define _SYSCALLS_H

/* 
 syscall definitions
 */
int64_t chf_open64 (const char *path, int oflag, mode_t mode);
int64_t chf_open   (const char *path, int oflag, mode_t mode);
int64_t chf_creat  (const char *path, mode_t mode);
int64_t chf_creat64(const char *path, mode_t mode);
int64_t chf_mkdir  (const char *path, mode_t mode);
int64_t chf_rmdir  (const char *path);
int64_t chf_rename (const char *existing, const char *new);
int64_t chf_symlink(const char *existing, const char *new);
int64_t chf_link   (const char *existing, const char *new);
int64_t chf_unlink (const char *path);
int64_t chf_execve (const char *path, char *const argv[], char *const envp[]);
int64_t chf_putmsg (int fildes, struct strbuf *ctlptr,
		    struct strbuf *dataptr, int *flagsp);
int64_t chf_chroot (const char *path);
int64_t chf_mount  (const char *spec, const char *dir, int mflag, char
		    *fstype, char *dataptr, int datalen, char *optptr, int
		    optlen);
int64_t chf_mknod  (const char *path, mode_t mode, dev_t dev);
int64_t chf_xmknod (const char *path, mode_t mode, dev_t dev);
int64_t chf_modctl (int cmd, uintptr_t a1, uintptr_t a2,
		    uintptr_t a3, uintptr_t a4, uintptr_t a5);
int64_t chf_chmod  (const char *path, mode_t mode);

#if defined(_64BIT) && defined(_KERNEL)
int64_t chf_creat32   (const char *path, mode_t mode);
int64_t chf_creat32_64(const char *path, mode_t mode);
int64_t chf_open32    (const char *path, int oflag, mode_t mode);
int64_t chf_open64_32 (const char *path, int oflag, mode_t mode);
int64_t chf_putmsg32  (int fildes, struct strbuf32 *ctlptr,
		       struct strbuf32 *dataptr, int *flagsp);
int64_t chf_xmknod32  (const char *path, mode_t mode, dev_t dev);
#endif

int chf_praccess(struct vnode *vp, int mode, int flags, struct cred *cr);
int chf_vnlookup(struct vnode *dvp, char *nm, struct vnode **vpp,
		 struct pathname *pnp, int flags, struct vnode *rdir,
		 struct cred *);
int chf_vnreaddir(struct vnode *vp, struct uio *uiop, struct cred *cr,
		  int *eofp);

#endif				/* _SYSCALLS_H */
